import QtQuick
import QtQuick.Layouts
import Quickshell
import Quickshell.Wayland
import Quickshell.Widgets
import "root:/"

BarWidget {
    id: wrapper
    property int maxWidth: 100
    Layout.fillWidth: true

    function getIcon() {
        var icon = Quickshell.iconPath(ToplevelManager.activeToplevel.appId.toLowerCase(), true);
        if (!icon) {
            icon = Quickshell.iconPath(ToplevelManager.activeToplevel.appId, true);
        }
        if (!icon) {
            icon = Quickshell.iconPath(ToplevelManager.activeToplevel.title, true);
        }
        if (!icon) {
            icon = Quickshell.iconPath(ToplevelManager.activeToplevel.title.toLowerCase(), "application-x-executable");
        }

        return icon;
    }

    RowLayout {
        width: parent.width
        height: parent.height
        spacing: 4

        Item {
            Layout.fillWidth: true
            Layout.preferredWidth: parent.width / 2
        }

        IconImage {
            id: icon
            implicitHeight: 20
            implicitWidth: 20
            source: ToplevelManager.activeToplevel ? getIcon() : "" 
        }

        Text {
            id: text
            Layout.fillWidth: false
            Layout.maximumWidth: wrapper.maxWidth - icon.implicitWidth - 32
            horizontalAlignment: Text.AlignLeft
            text: ToplevelManager.activeToplevel?.title ?? ""
            color: Globals.commonStyles.textColor
            font.pointSize: Globals.commonStyles.textFontSizeSmall
            font.family: Globals.commonStyles.fontFamily
            font.weight: Globals.commonStyles.fontWeight
            elide: Text.ElideRight
            maximumLineCount: 1
        }

        Item {
            Layout.fillWidth: true
            Layout.preferredWidth: parent.width / 2
        }
    }
}
